#line 1 "C:/Users/Corey/Documents/Projects/C_Meter/FT90/C_Meter_FT90.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for ft90x/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for ft90x/include/stdbool.h"



 typedef char _Bool;
#line 5 "C:/Users/Corey/Documents/Projects/C_Meter/FT90/C_Meter_FT90.c"
sbit C_METER_RST at GPIO_PIN1_bit;
sbit C_METER_INT at GPIO_PIN3_bit;

void system_setup( void );
void setup_interrupt( void );
void InitTimerA( void );

volatile  _Bool  flag;
volatile uint32_t start_val;
volatile uint32_t end_val;
char uart_text[ 40 ];
char final_text[ 40 ];
uint32_t int_count = 0;
uint32_t timer_count_end = 0;
 _Bool  sec_flag =  0 ;
volatile float c_cal = 0.0;
volatile float t_meas = 0.0;
volatile float c_meas = 0.0;
volatile float final = 0.0;
volatile float t_cal = 0.0;


void main()
{

  _Bool  calibration_flag =  1 ;

 system_setup();
 setup_interrupt();
 InitTimerA();

 t_cal = 1.0 / 11278.0;
 c_cal = t_cal / 77616.0;

 int_count = 0;

 while(1)
 {

 if( sec_flag )
 {

 sprintf( uart_text, "Interrupts : %u\r\n", timer_count_end );
 UART1_Write_Text( uart_text );

 t_meas = 1.0 / timer_count_end;
 c_meas = t_meas / 77616.0;
 final = fabs( c_cal - c_meas );

 UART1_Write_Text( "Calibrated: " );
 FloatToStr( c_cal, uart_text );
 UART1_Write_Text( uart_text );
 UART1_Write_Text( "\r\n" );
 UART1_Write_Text( "Final: " );
 FloatToStr( final, final_text );
 UART1_Write_Text( final_text );
 UART1_Write_Text( "\r\n" );

 sec_flag =  0 ;
 int_count = 0;
 timer_count_end = 0;
 }
 }
}

void system_setup( void )
{

 GPIO_Digital_Output(&GPIO_PORT_00_07, _GPIO_PINMASK_1 );
 GPIO_Digital_Input(&GPIO_PORT_00_07, _GPIO_PINMASK_3 );


 C_METER_RST = 0;
 Delay_ms(50);
 C_METER_RST = 1;


 UART1_Init( 9600 );
 UART1_Write_Text( "UART Initialized\r\n" );

}

void setup_interrupt( void )
{



 IRQ_CTRL.B31 = 0;


 GPIO03_CFG0_bit = 1;


 GPIO03_CFG1_bit = 1;



 GPIO03_CFG2_bit = 0;
 GPIO03_CFG3_bit = 0;


 GPIO_INT_EN_00_31bits.GPIO_INT_EN3 = 1;
}

void interrupt() iv IVT_GPIO_IRQ{
 Delay_50us();


 GPIO_INT_PEND_00_31bits.GPIO_INT_PEND3 = 1;
 int_count++;
}

void InitTimerA()
{
 TIMER_CONTROL_0 = 2;
 TIMER_SELECT = 0;
 TIMER_PRESC_LS = 36;
 TIMER_PRESC_MS = 244;
 TIMER_WRITE_LS = 63;
 TIMER_WRITE_MS = 6;
 TIMER_CONTROL_3 = 0;
 TIMER_CONTROL_4 |= 17;
 TIMER_CONTROL_2 |= 16;
 TIMER_INT |= 2;
 TIMER_CONTROL_1 |= 1;
}
void TimerInterrupt() iv IVT_TIMERS_IRQ{

 if (TIMER_INT_A_bit)
 {
 TIMER_INT = (TIMER_INT & 0xAA) | (1 << 0);
 timer_count_end = int_count;
 int_count = 0;
 sec_flag =  1 ;
 }
}
